(set-info :smt-lib-version 2.6)
(set-logic UF)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/dl/dl_traverse.spl:23:3-4:An invariant might not be maintained by a loop in procedure dl_traverse
  tests/spl/dl/dl_traverse.spl:19:14-68:Related location: This is the loop invariant that might not be maintained
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun emptyset$0 () SetLoc)
(declare-fun setenum$0 (Loc) SetLoc)
(declare-fun union$0 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun in$0 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom_11$0 () Bool)
(declare-fun Axiom_12$0 () Bool)
(declare-fun Axiom_13$0 () Bool)
(declare-fun Axiom_14$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_2$0 () SetLoc)
(declare-fun a_2$0 () Loc)
(declare-fun a_init$0 () Loc)
(declare-fun b_2$0 () Loc)
(declare-fun b_init$0 () Loc)
(declare-fun curr_4$0 () Loc)
(declare-fun curr_5$0 () Loc)
(declare-fun curr_init$0 () Loc)
(declare-fun dlseg_domain$0 (FldLoc FldLoc Loc Loc Loc Loc) SetLoc)
(declare-fun dlseg_struct$0 (SetLoc FldLoc FldLoc Loc Loc Loc Loc) Bool)
(declare-fun lst_2$0 () Loc)
(declare-fun lst_init$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun prev$0 () FldLoc)
(declare-fun prv_4$0 () Loc)
(declare-fun prv_5$0 () Loc)
(declare-fun prv_init$0 () Loc)
(declare-fun sk_?X_15$0 () SetLoc)
(declare-fun sk_?X_16$0 () SetLoc)
(declare-fun sk_?X_17$0 () SetLoc)
(declare-fun sk_?X_18$0 () SetLoc)
(declare-fun sk_?X_19$0 () SetLoc)
(declare-fun sk_?X_20$0 () SetLoc)
(declare-fun sk_FP_1$0 () SetLoc)
(declare-fun sk_l1_2$0 () Loc)
(declare-fun sk_l2_2$0 () Loc)

(assert (forall ((?y Loc))
        (or (not (Btwn$0 next$0 null$0 ?y ?y)) (= null$0 ?y)
            (Btwn$0 next$0 null$0 (read$0 next$0 null$0) ?y))))

(assert (forall ((?y Loc))
        (or (not (Btwn$0 next$0 b_init$0 ?y ?y)) (= b_init$0 ?y)
            (Btwn$0 next$0 b_init$0 (read$0 next$0 b_init$0) ?y))))

(assert (forall ((?y Loc))
        (or (not (Btwn$0 next$0 prv_init$0 ?y ?y)) (= prv_init$0 ?y)
            (Btwn$0 next$0 prv_init$0 (read$0 next$0 prv_init$0) ?y))))

(assert (forall ((?y Loc))
        (or (not (Btwn$0 next$0 sk_l1_2$0 ?y ?y)) (= sk_l1_2$0 ?y)
            (Btwn$0 next$0 sk_l1_2$0 (read$0 next$0 sk_l1_2$0) ?y))))

(assert (forall ((?y Loc))
        (or (not (Btwn$0 next$0 curr_init$0 ?y ?y)) (= curr_init$0 ?y)
            (Btwn$0 next$0 curr_init$0 (read$0 next$0 curr_init$0) ?y))))

(assert (forall ((?y Loc))
        (or (not (= (read$0 next$0 null$0) null$0))
            (not (Btwn$0 next$0 null$0 ?y ?y)) (= null$0 ?y))))

(assert (forall ((?y Loc))
        (or (not (= (read$0 next$0 b_init$0) b_init$0))
            (not (Btwn$0 next$0 b_init$0 ?y ?y)) (= b_init$0 ?y))))

(assert (forall ((?y Loc))
        (or (not (= (read$0 next$0 prv_init$0) prv_init$0))
            (not (Btwn$0 next$0 prv_init$0 ?y ?y)) (= prv_init$0 ?y))))

(assert (forall ((?y Loc))
        (or (not (= (read$0 next$0 sk_l1_2$0) sk_l1_2$0))
            (not (Btwn$0 next$0 sk_l1_2$0 ?y ?y)) (= sk_l1_2$0 ?y))))

(assert (forall ((?y Loc))
        (or (not (= (read$0 next$0 curr_init$0) curr_init$0))
            (not (Btwn$0 next$0 curr_init$0 ?y ?y)) (= curr_init$0 ?y))))

(assert (Btwn$0 next$0 null$0 (read$0 next$0 null$0) (read$0 next$0 null$0)))

(assert (Btwn$0 next$0 b_init$0 (read$0 next$0 b_init$0) (read$0 next$0 b_init$0)))

(assert (Btwn$0 next$0 prv_init$0 (read$0 next$0 prv_init$0)
  (read$0 next$0 prv_init$0)))

(assert (Btwn$0 next$0 sk_l1_2$0 (read$0 next$0 sk_l1_2$0) (read$0 next$0 sk_l1_2$0)))

(assert (Btwn$0 next$0 curr_init$0 (read$0 next$0 curr_init$0)
  (read$0 next$0 curr_init$0)))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 null$0) null$0)
        (not (= (read$0 next$0 null$0) null$0))
        (not (in$0 null$0 sk_?X_20$0)) (not (in$0 null$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 null$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) null$0))
        (not (in$0 b_init$0 sk_?X_20$0)) (not (in$0 null$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 null$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) null$0))
        (not (in$0 prv_init$0 sk_?X_20$0)) (not (in$0 null$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 null$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) null$0))
        (not (in$0 sk_l1_2$0 sk_?X_20$0)) (not (in$0 null$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 null$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) null$0))
        (not (in$0 curr_init$0 sk_?X_20$0)) (not (in$0 null$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 curr_5$0) null$0)
        (not (= (read$0 next$0 null$0) curr_5$0))
        (not (in$0 null$0 sk_?X_20$0)) (not (in$0 curr_5$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 curr_5$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) curr_5$0))
        (not (in$0 b_init$0 sk_?X_20$0)) (not (in$0 curr_5$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 curr_5$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) curr_5$0))
        (not (in$0 prv_init$0 sk_?X_20$0)) (not (in$0 curr_5$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 curr_5$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) curr_5$0))
        (not (in$0 sk_l1_2$0 sk_?X_20$0)) (not (in$0 curr_5$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 curr_5$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) curr_5$0))
        (not (in$0 curr_init$0 sk_?X_20$0)) (not (in$0 curr_5$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 curr_init$0) null$0)
        (not (= (read$0 next$0 null$0) curr_init$0))
        (not (in$0 null$0 sk_?X_20$0)) (not (in$0 curr_init$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 curr_init$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) curr_init$0))
        (not (in$0 b_init$0 sk_?X_20$0)) (not (in$0 curr_init$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 curr_init$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) curr_init$0))
        (not (in$0 prv_init$0 sk_?X_20$0))
        (not (in$0 curr_init$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 curr_init$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) curr_init$0))
        (not (in$0 sk_l1_2$0 sk_?X_20$0))
        (not (in$0 curr_init$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 curr_init$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) curr_init$0))
        (not (in$0 curr_init$0 sk_?X_20$0))
        (not (in$0 curr_init$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 lst_2$0) null$0)
        (not (= (read$0 next$0 null$0) lst_2$0))
        (not (in$0 null$0 sk_?X_20$0)) (not (in$0 lst_2$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 lst_2$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) lst_2$0))
        (not (in$0 b_init$0 sk_?X_20$0)) (not (in$0 lst_2$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 lst_2$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) lst_2$0))
        (not (in$0 prv_init$0 sk_?X_20$0)) (not (in$0 lst_2$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 lst_2$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) lst_2$0))
        (not (in$0 sk_l1_2$0 sk_?X_20$0)) (not (in$0 lst_2$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 lst_2$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) lst_2$0))
        (not (in$0 curr_init$0 sk_?X_20$0)) (not (in$0 lst_2$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 sk_l2_2$0) null$0)
        (not (= (read$0 next$0 null$0) sk_l2_2$0))
        (not (in$0 null$0 sk_?X_20$0)) (not (in$0 sk_l2_2$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 sk_l2_2$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) sk_l2_2$0))
        (not (in$0 b_init$0 sk_?X_20$0)) (not (in$0 sk_l2_2$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 sk_l2_2$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) sk_l2_2$0))
        (not (in$0 prv_init$0 sk_?X_20$0)) (not (in$0 sk_l2_2$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 sk_l2_2$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) sk_l2_2$0))
        (not (in$0 sk_l1_2$0 sk_?X_20$0)) (not (in$0 sk_l2_2$0 sk_?X_20$0)))))

(assert (or (not Axiom_13$0)
    (or (= (read$0 prev$0 sk_l2_2$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) sk_l2_2$0))
        (not (in$0 curr_init$0 sk_?X_20$0))
        (not (in$0 sk_l2_2$0 sk_?X_20$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 null$0) null$0)
        (not (= (read$0 next$0 null$0) null$0))
        (not (in$0 null$0 sk_?X_19$0)) (not (in$0 null$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 null$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) null$0))
        (not (in$0 b_init$0 sk_?X_19$0)) (not (in$0 null$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 null$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) null$0))
        (not (in$0 prv_init$0 sk_?X_19$0)) (not (in$0 null$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 null$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) null$0))
        (not (in$0 sk_l1_2$0 sk_?X_19$0)) (not (in$0 null$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 null$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) null$0))
        (not (in$0 curr_init$0 sk_?X_19$0)) (not (in$0 null$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 curr_5$0) null$0)
        (not (= (read$0 next$0 null$0) curr_5$0))
        (not (in$0 null$0 sk_?X_19$0)) (not (in$0 curr_5$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 curr_5$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) curr_5$0))
        (not (in$0 b_init$0 sk_?X_19$0)) (not (in$0 curr_5$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 curr_5$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) curr_5$0))
        (not (in$0 prv_init$0 sk_?X_19$0)) (not (in$0 curr_5$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 curr_5$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) curr_5$0))
        (not (in$0 sk_l1_2$0 sk_?X_19$0)) (not (in$0 curr_5$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 curr_5$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) curr_5$0))
        (not (in$0 curr_init$0 sk_?X_19$0)) (not (in$0 curr_5$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 curr_init$0) null$0)
        (not (= (read$0 next$0 null$0) curr_init$0))
        (not (in$0 null$0 sk_?X_19$0)) (not (in$0 curr_init$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 curr_init$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) curr_init$0))
        (not (in$0 b_init$0 sk_?X_19$0)) (not (in$0 curr_init$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 curr_init$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) curr_init$0))
        (not (in$0 prv_init$0 sk_?X_19$0))
        (not (in$0 curr_init$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 curr_init$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) curr_init$0))
        (not (in$0 sk_l1_2$0 sk_?X_19$0))
        (not (in$0 curr_init$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 curr_init$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) curr_init$0))
        (not (in$0 curr_init$0 sk_?X_19$0))
        (not (in$0 curr_init$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 lst_2$0) null$0)
        (not (= (read$0 next$0 null$0) lst_2$0))
        (not (in$0 null$0 sk_?X_19$0)) (not (in$0 lst_2$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 lst_2$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) lst_2$0))
        (not (in$0 b_init$0 sk_?X_19$0)) (not (in$0 lst_2$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 lst_2$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) lst_2$0))
        (not (in$0 prv_init$0 sk_?X_19$0)) (not (in$0 lst_2$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 lst_2$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) lst_2$0))
        (not (in$0 sk_l1_2$0 sk_?X_19$0)) (not (in$0 lst_2$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 lst_2$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) lst_2$0))
        (not (in$0 curr_init$0 sk_?X_19$0)) (not (in$0 lst_2$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 sk_l2_2$0) null$0)
        (not (= (read$0 next$0 null$0) sk_l2_2$0))
        (not (in$0 null$0 sk_?X_19$0)) (not (in$0 sk_l2_2$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 sk_l2_2$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) sk_l2_2$0))
        (not (in$0 b_init$0 sk_?X_19$0)) (not (in$0 sk_l2_2$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 sk_l2_2$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) sk_l2_2$0))
        (not (in$0 prv_init$0 sk_?X_19$0)) (not (in$0 sk_l2_2$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 sk_l2_2$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) sk_l2_2$0))
        (not (in$0 sk_l1_2$0 sk_?X_19$0)) (not (in$0 sk_l2_2$0 sk_?X_19$0)))))

(assert (or (not Axiom_11$0)
    (or (= (read$0 prev$0 sk_l2_2$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) sk_l2_2$0))
        (not (in$0 curr_init$0 sk_?X_19$0))
        (not (in$0 sk_l2_2$0 sk_?X_19$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 null$0) null$0)
        (not (= (read$0 next$0 null$0) null$0))
        (not (in$0 null$0 sk_?X_17$0)) (not (in$0 null$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 null$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) null$0))
        (not (in$0 b_init$0 sk_?X_17$0)) (not (in$0 null$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 null$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) null$0))
        (not (in$0 prv_init$0 sk_?X_17$0)) (not (in$0 null$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 null$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) null$0))
        (not (in$0 sk_l1_2$0 sk_?X_17$0)) (not (in$0 null$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 null$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) null$0))
        (not (in$0 curr_init$0 sk_?X_17$0)) (not (in$0 null$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 curr_5$0) null$0)
        (not (= (read$0 next$0 null$0) curr_5$0))
        (not (in$0 null$0 sk_?X_17$0)) (not (in$0 curr_5$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 curr_5$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) curr_5$0))
        (not (in$0 b_init$0 sk_?X_17$0)) (not (in$0 curr_5$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 curr_5$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) curr_5$0))
        (not (in$0 prv_init$0 sk_?X_17$0)) (not (in$0 curr_5$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 curr_5$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) curr_5$0))
        (not (in$0 sk_l1_2$0 sk_?X_17$0)) (not (in$0 curr_5$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 curr_5$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) curr_5$0))
        (not (in$0 curr_init$0 sk_?X_17$0)) (not (in$0 curr_5$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 curr_init$0) null$0)
        (not (= (read$0 next$0 null$0) curr_init$0))
        (not (in$0 null$0 sk_?X_17$0)) (not (in$0 curr_init$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 curr_init$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) curr_init$0))
        (not (in$0 b_init$0 sk_?X_17$0)) (not (in$0 curr_init$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 curr_init$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) curr_init$0))
        (not (in$0 prv_init$0 sk_?X_17$0))
        (not (in$0 curr_init$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 curr_init$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) curr_init$0))
        (not (in$0 sk_l1_2$0 sk_?X_17$0))
        (not (in$0 curr_init$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 curr_init$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) curr_init$0))
        (not (in$0 curr_init$0 sk_?X_17$0))
        (not (in$0 curr_init$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 lst_2$0) null$0)
        (not (= (read$0 next$0 null$0) lst_2$0))
        (not (in$0 null$0 sk_?X_17$0)) (not (in$0 lst_2$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 lst_2$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) lst_2$0))
        (not (in$0 b_init$0 sk_?X_17$0)) (not (in$0 lst_2$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 lst_2$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) lst_2$0))
        (not (in$0 prv_init$0 sk_?X_17$0)) (not (in$0 lst_2$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 lst_2$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) lst_2$0))
        (not (in$0 sk_l1_2$0 sk_?X_17$0)) (not (in$0 lst_2$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 lst_2$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) lst_2$0))
        (not (in$0 curr_init$0 sk_?X_17$0)) (not (in$0 lst_2$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 sk_l2_2$0) null$0)
        (not (= (read$0 next$0 null$0) sk_l2_2$0))
        (not (in$0 null$0 sk_?X_17$0)) (not (in$0 sk_l2_2$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 sk_l2_2$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) sk_l2_2$0))
        (not (in$0 b_init$0 sk_?X_17$0)) (not (in$0 sk_l2_2$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 sk_l2_2$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) sk_l2_2$0))
        (not (in$0 prv_init$0 sk_?X_17$0)) (not (in$0 sk_l2_2$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 sk_l2_2$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) sk_l2_2$0))
        (not (in$0 sk_l1_2$0 sk_?X_17$0)) (not (in$0 sk_l2_2$0 sk_?X_17$0)))))

(assert (or (not Axiom_14$0)
    (or (= (read$0 prev$0 sk_l2_2$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) sk_l2_2$0))
        (not (in$0 curr_init$0 sk_?X_17$0))
        (not (in$0 sk_l2_2$0 sk_?X_17$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 null$0) null$0)
        (not (= (read$0 next$0 null$0) null$0))
        (not (in$0 null$0 sk_?X_16$0)) (not (in$0 null$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 null$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) null$0))
        (not (in$0 b_init$0 sk_?X_16$0)) (not (in$0 null$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 null$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) null$0))
        (not (in$0 prv_init$0 sk_?X_16$0)) (not (in$0 null$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 null$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) null$0))
        (not (in$0 sk_l1_2$0 sk_?X_16$0)) (not (in$0 null$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 null$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) null$0))
        (not (in$0 curr_init$0 sk_?X_16$0)) (not (in$0 null$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 curr_5$0) null$0)
        (not (= (read$0 next$0 null$0) curr_5$0))
        (not (in$0 null$0 sk_?X_16$0)) (not (in$0 curr_5$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 curr_5$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) curr_5$0))
        (not (in$0 b_init$0 sk_?X_16$0)) (not (in$0 curr_5$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 curr_5$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) curr_5$0))
        (not (in$0 prv_init$0 sk_?X_16$0)) (not (in$0 curr_5$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 curr_5$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) curr_5$0))
        (not (in$0 sk_l1_2$0 sk_?X_16$0)) (not (in$0 curr_5$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 curr_5$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) curr_5$0))
        (not (in$0 curr_init$0 sk_?X_16$0)) (not (in$0 curr_5$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 curr_init$0) null$0)
        (not (= (read$0 next$0 null$0) curr_init$0))
        (not (in$0 null$0 sk_?X_16$0)) (not (in$0 curr_init$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 curr_init$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) curr_init$0))
        (not (in$0 b_init$0 sk_?X_16$0)) (not (in$0 curr_init$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 curr_init$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) curr_init$0))
        (not (in$0 prv_init$0 sk_?X_16$0))
        (not (in$0 curr_init$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 curr_init$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) curr_init$0))
        (not (in$0 sk_l1_2$0 sk_?X_16$0))
        (not (in$0 curr_init$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 curr_init$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) curr_init$0))
        (not (in$0 curr_init$0 sk_?X_16$0))
        (not (in$0 curr_init$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 lst_2$0) null$0)
        (not (= (read$0 next$0 null$0) lst_2$0))
        (not (in$0 null$0 sk_?X_16$0)) (not (in$0 lst_2$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 lst_2$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) lst_2$0))
        (not (in$0 b_init$0 sk_?X_16$0)) (not (in$0 lst_2$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 lst_2$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) lst_2$0))
        (not (in$0 prv_init$0 sk_?X_16$0)) (not (in$0 lst_2$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 lst_2$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) lst_2$0))
        (not (in$0 sk_l1_2$0 sk_?X_16$0)) (not (in$0 lst_2$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 lst_2$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) lst_2$0))
        (not (in$0 curr_init$0 sk_?X_16$0)) (not (in$0 lst_2$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 sk_l2_2$0) null$0)
        (not (= (read$0 next$0 null$0) sk_l2_2$0))
        (not (in$0 null$0 sk_?X_16$0)) (not (in$0 sk_l2_2$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 sk_l2_2$0) b_init$0)
        (not (= (read$0 next$0 b_init$0) sk_l2_2$0))
        (not (in$0 b_init$0 sk_?X_16$0)) (not (in$0 sk_l2_2$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 sk_l2_2$0) prv_init$0)
        (not (= (read$0 next$0 prv_init$0) sk_l2_2$0))
        (not (in$0 prv_init$0 sk_?X_16$0)) (not (in$0 sk_l2_2$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 sk_l2_2$0) sk_l1_2$0)
        (not (= (read$0 next$0 sk_l1_2$0) sk_l2_2$0))
        (not (in$0 sk_l1_2$0 sk_?X_16$0)) (not (in$0 sk_l2_2$0 sk_?X_16$0)))))

(assert (or (not Axiom_12$0)
    (or (= (read$0 prev$0 sk_l2_2$0) curr_init$0)
        (not (= (read$0 next$0 curr_init$0) sk_l2_2$0))
        (not (in$0 curr_init$0 sk_?X_16$0))
        (not (in$0 sk_l2_2$0 sk_?X_16$0)))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 FP_Caller$0 Alloc$0))
                 (or (in$0 x FP_Caller$0) (in$0 x Alloc$0)))
            (and (not (in$0 x FP_Caller$0)) (not (in$0 x Alloc$0))
                 (not (in$0 x (union$0 FP_Caller$0 Alloc$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 sk_?X_17$0 sk_?X_16$0))
                 (or (in$0 x sk_?X_17$0) (in$0 x sk_?X_16$0)))
            (and (not (in$0 x sk_?X_17$0)) (not (in$0 x sk_?X_16$0))
                 (not (in$0 x (union$0 sk_?X_17$0 sk_?X_16$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 FP$0 FP_Caller$0))
                 (or (in$0 x FP$0) (in$0 x FP_Caller$0)))
            (and (not (in$0 x FP$0)) (not (in$0 x FP_Caller$0))
                 (not (in$0 x (union$0 FP$0 FP_Caller$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x (union$0 sk_?X_20$0 sk_?X_19$0))
                 (or (in$0 x sk_?X_20$0) (in$0 x sk_?X_19$0)))
            (and (not (in$0 x sk_?X_20$0)) (not (in$0 x sk_?X_19$0))
                 (not (in$0 x (union$0 sk_?X_20$0 sk_?X_19$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x sk_?X_17$0) (in$0 x sk_?X_16$0)
                 (in$0 x (intersection$0 sk_?X_17$0 sk_?X_16$0)))
            (and (or (not (in$0 x sk_?X_17$0)) (not (in$0 x sk_?X_16$0)))
                 (not (in$0 x (intersection$0 sk_?X_17$0 sk_?X_16$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x sk_?X_20$0) (in$0 x sk_?X_19$0)
                 (in$0 x (intersection$0 sk_?X_20$0 sk_?X_19$0)))
            (and (or (not (in$0 x sk_?X_20$0)) (not (in$0 x sk_?X_19$0)))
                 (not (in$0 x (intersection$0 sk_?X_20$0 sk_?X_19$0)))))))

(assert (forall ((x Loc))
        (or
            (and (in$0 x FP_Caller$0) (in$0 x (setminus$0 FP_Caller$0 FP$0))
                 (not (in$0 x FP$0)))
            (and (or (in$0 x FP$0) (not (in$0 x FP_Caller$0)))
                 (not (in$0 x (setminus$0 FP_Caller$0 FP$0)))))))

(assert (forall ((y Loc) (x Loc))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (= (read$0 next$0 null$0) null$0))

(assert (= (read$0 prev$0 null$0) null$0))

(assert (forall ((x Loc)) (not (in$0 x emptyset$0))))

(assert (or
    (and (Btwn$0 next$0 curr_5$0 null$0 null$0)
         (or
             (and (= (read$0 next$0 b_2$0) null$0)
                  (= (read$0 prev$0 curr_5$0) prv_5$0)
                  (in$0 b_2$0 sk_?X_19$0))
             (and (= curr_5$0 null$0) (= prv_5$0 b_2$0)))
         Axiom_11$0)
    (not
         (dlseg_struct$0 sk_?X_19$0 next$0 prev$0 curr_5$0 prv_5$0 null$0
           b_2$0))))

(assert (or
    (and (Btwn$0 next$0 lst_2$0 curr_5$0 curr_5$0)
         (or
             (and (= (read$0 next$0 prv_5$0) curr_5$0)
                  (= (read$0 prev$0 lst_2$0) a_2$0)
                  (in$0 prv_5$0 sk_?X_20$0))
             (and (= a_2$0 prv_5$0) (= lst_2$0 curr_5$0)))
         Axiom_13$0)
    (not
         (dlseg_struct$0 sk_?X_20$0 next$0 prev$0 lst_2$0 a_2$0 curr_5$0
           prv_5$0))))

(assert (= FP_Caller_2$0 (setminus$0 FP_Caller$0 FP$0)))

(assert (= b_2$0 b_init$0))

(assert (= curr_5$0 (read$0 next$0 curr_4$0)))

(assert (= prv_4$0 prv_init$0))

(assert (= Alloc$0 (union$0 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_15$0 (union$0 sk_?X_17$0 sk_?X_16$0)))

(assert (= sk_?X_16$0
  (dlseg_domain$0 next$0 prev$0 curr_init$0 prv_init$0 null$0 b_init$0)))

(assert (= FP_Caller$0 (union$0 FP$0 FP_Caller$0)))

(assert (dlseg_struct$0 sk_?X_17$0 next$0 prev$0 lst_init$0 a_init$0 curr_init$0
  prv_init$0))

(assert (= sk_?X_19$0 (dlseg_domain$0 next$0 prev$0 curr_5$0 prv_5$0 null$0 b_2$0)))

(assert (= sk_FP_1$0 sk_?X_18$0))

(assert (not (= curr_4$0 null$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_5$0 l1 null$0)
                 (in$0 l1
                   (dlseg_domain$0 next$0 prev$0 curr_5$0 prv_5$0 null$0
                     b_2$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_5$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (dlseg_domain$0 next$0 prev$0 curr_5$0 prv_5$0 null$0
                          b_2$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_2$0 l1 curr_5$0)
                 (in$0 l1
                   (dlseg_domain$0 next$0 prev$0 lst_2$0 a_2$0 curr_5$0
                     prv_5$0))
                 (not (= l1 curr_5$0)))
            (and
                 (or (= l1 curr_5$0)
                     (not (Btwn$0 next$0 lst_2$0 l1 curr_5$0)))
                 (not
                      (in$0 l1
                        (dlseg_domain$0 next$0 prev$0 lst_2$0 a_2$0 curr_5$0
                          prv_5$0)))))))

(assert (or
    (and (Btwn$0 next$0 curr_init$0 null$0 null$0)
         (or
             (and (= (read$0 next$0 b_init$0) null$0)
                  (= (read$0 prev$0 curr_init$0) prv_init$0)
                  (in$0 b_init$0 sk_?X_16$0))
             (and (= curr_init$0 null$0) (= prv_init$0 b_init$0)))
         Axiom_12$0)
    (not
         (dlseg_struct$0 sk_?X_16$0 next$0 prev$0 curr_init$0 prv_init$0
           null$0 b_init$0))))

(assert (or
    (and (Btwn$0 next$0 lst_init$0 curr_init$0 curr_init$0)
         (or
             (and (= (read$0 next$0 prv_init$0) curr_init$0)
                  (= (read$0 prev$0 lst_init$0) a_init$0)
                  (in$0 prv_init$0 sk_?X_17$0))
             (and (= a_init$0 prv_init$0) (= lst_init$0 curr_init$0)))
         Axiom_14$0)
    (not
         (dlseg_struct$0 sk_?X_17$0 next$0 prev$0 lst_init$0 a_init$0
           curr_init$0 prv_init$0))))

(assert (= a_2$0 a_init$0))

(assert (= curr_4$0 curr_init$0))

(assert (= lst_2$0 lst_init$0))

(assert (= prv_5$0 curr_4$0))

(assert (= emptyset$0 (intersection$0 sk_?X_17$0 sk_?X_16$0)))

(assert (= sk_?X_15$0 FP$0))

(assert (= sk_?X_17$0
  (dlseg_domain$0 next$0 prev$0 lst_init$0 a_init$0 curr_init$0 prv_init$0)))

(assert (dlseg_struct$0 sk_?X_16$0 next$0 prev$0 curr_init$0 prv_init$0 null$0
  b_init$0))

(assert (= sk_?X_18$0 (union$0 sk_?X_20$0 sk_?X_19$0)))

(assert (= sk_?X_20$0 (dlseg_domain$0 next$0 prev$0 lst_2$0 a_2$0 curr_5$0 prv_5$0)))

(assert (or (in$0 sk_l2_2$0 (intersection$0 sk_?X_20$0 sk_?X_19$0))
    (and (= (read$0 next$0 sk_l1_2$0) sk_l2_2$0) (in$0 sk_l1_2$0 sk_?X_19$0)
         (in$0 sk_l2_2$0 sk_?X_19$0)
         (not (= (read$0 prev$0 sk_l2_2$0) sk_l1_2$0)))
    (and (= (read$0 next$0 sk_l1_2$0) sk_l2_2$0) (in$0 sk_l1_2$0 sk_?X_20$0)
         (in$0 sk_l2_2$0 sk_?X_20$0)
         (not (= (read$0 prev$0 sk_l2_2$0) sk_l1_2$0)))
    (and (in$0 sk_l1_2$0 sk_FP_1$0) (not (in$0 sk_l1_2$0 FP$0)))
    (and
         (or (not (= (read$0 next$0 b_2$0) null$0))
             (not (= (read$0 prev$0 curr_5$0) prv_5$0))
             (not (in$0 b_2$0 sk_?X_19$0)))
         (or (not (= curr_5$0 null$0)) (not (= prv_5$0 b_2$0))))
    (and
         (or (not (= (read$0 next$0 prv_5$0) curr_5$0))
             (not (= (read$0 prev$0 lst_2$0) a_2$0))
             (not (in$0 prv_5$0 sk_?X_20$0)))
         (or (not (= a_2$0 prv_5$0)) (not (= lst_2$0 curr_5$0))))
    (not (Btwn$0 next$0 curr_5$0 null$0 null$0))
    (not (Btwn$0 next$0 lst_2$0 curr_5$0 curr_5$0))))

(assert (not (in$0 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_init$0 l1 null$0)
                 (in$0 l1
                   (dlseg_domain$0 next$0 prev$0 curr_init$0 prv_init$0
                     null$0 b_init$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 curr_init$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (dlseg_domain$0 next$0 prev$0 curr_init$0 prv_init$0
                          null$0 b_init$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_init$0 l1 curr_init$0)
                 (in$0 l1
                   (dlseg_domain$0 next$0 prev$0 lst_init$0 a_init$0
                     curr_init$0 prv_init$0))
                 (not (= l1 curr_init$0)))
            (and
                 (or (= l1 curr_init$0)
                     (not (Btwn$0 next$0 lst_init$0 l1 curr_init$0)))
                 (not
                      (in$0 l1
                        (dlseg_domain$0 next$0 prev$0 lst_init$0 a_init$0
                          curr_init$0 prv_init$0)))))))

(assert (forall ((?x Loc)) (Btwn$0 next$0 ?x ?x ?x)))

(assert (forall ((?x Loc) (?y Loc)) (or (not (Btwn$0 next$0 ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 next$0 ?x ?y ?y)) (not (Btwn$0 next$0 ?x ?z ?z))
            (Btwn$0 next$0 ?x ?y ?z) (Btwn$0 next$0 ?x ?z ?y))))

(assert (forall ((?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 next$0 ?x ?y ?z))
            (and (Btwn$0 next$0 ?x ?y ?y) (Btwn$0 next$0 ?y ?z ?z)))))

(assert (forall ((?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 next$0 ?x ?y ?y)) (not (Btwn$0 next$0 ?y ?z ?z))
            (Btwn$0 next$0 ?x ?z ?z))))

(assert (forall ((?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 next$0 ?x ?y ?z)) (not (Btwn$0 next$0 ?y ?u ?z))
            (and (Btwn$0 next$0 ?x ?y ?u) (Btwn$0 next$0 ?x ?u ?z)))))

(assert (forall ((?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 next$0 ?x ?y ?z)) (not (Btwn$0 next$0 ?x ?u ?y))
            (and (Btwn$0 next$0 ?x ?u ?z) (Btwn$0 next$0 ?u ?y ?z)))))

(check-sat)
(exit)
